package Java2.Detyra1;

public class EkipiOlimpik {
    private String emri;
    private Sportisti[] sportistet;
    int index = 0;

    public EkipiOlimpik(String e, int nrS){
        emri = e;
        sportistet = new Sportisti[nrS];
    }

    public void print(){
        if(index == 0){
            System.out.println("Ky ekip nuk ka asnje sportist/e!");
            return;
        }

        for(int i = 0; i < index; i++){
            System.out.println(sportistet[i]);
        }
    }

    public boolean ekziston(Sportisti s){
        for(int i = 0; i < index; i++){
            if(s.equals(sportistet[i])){
                return true;
            }
        }
        return false;
    }


    public void shtoSportistin(Sportisti s){
        if(s==null){
            System.out.println("Sportisti/ja nuk mund te shtohet, sepse ka vleren null!"); 
        }
        else if(index == sportistet.length){
            System.out.println("Nuk ka vend ne ekip per te shtuar sportistin/en: " + s + "!");
        }
        else if(ekziston(s)){
            System.out.println("Sportisti/ja: " + s + " vetem se gjendet ne ekip!"); 
        }
        else{
            sportistet[index++]=s;
        }
    }

    public void shtypFutbollistetGjinia(char gj){
        if(index == 0){
            System.out.println("Ky ekip nuk ka asnje sportist/e!");
            return;
        }

        for(int i = 0; i < index; i++){
            if(sportistet[i] instanceof Futbollisti && ((Futbollisti) sportistet[i]).getGjinia() == gj){
                System.out.println(sportistet[i]);
            }
        }
    }

    public void shtypKaratistetMeTeRi(int m){
        if(index == 0){
            System.out.println("Ky ekip nuk ka asnje sportist/e!");
            return;
        }

        for(int i = 0; i < index; i++){
            if(sportistet[i].getMosha() < m){
                System.out.println(sportistet[i]);
            }
        }
    }

    public Sportisti[] ktheNumrat(int nr){
        if(index == 0){
            System.out.println("Ky ekip nuk ka asnje sportist/e!");
            return null;
        }

        Sportisti[] spNr = null;
        int count = 0;
        for(int i = 0; i < index; i++){
            if(sportistet[i] instanceof Futbollisti && ((Futbollisti)sportistet[i]).getNumri() > nr){
                count++;
            }
        }

        if(count == 0){
            System.out.println("Ne kete ekip, asnje sportisti/eje nuk ka numer me te madh se : " + nr);
            return null;
        }

        spNr = new Sportisti[count];
        int pozita = 0;
        for(int i = 0; i < index; i++){
            if(sportistet[i] instanceof Futbollisti && ((Futbollisti)sportistet[i]).getNumri() > nr){
                spNr[pozita++] = sportistet[i];
            }
        }

        return spNr;
    }

    public int fshijSipasStilit(String s){
        if(index == 0){
            System.out.println("Ky ekip nuk ka asnje sportist/e!");
            return 0;
        }

        int count = 0;
        for(int i = 0; i < index; i++){
            if(sportistet[i] instanceof Karateisti && ((Karateisti)sportistet[i]).getStili().equalsIgnoreCase(s) ){
                for(int j = i; j < index-1; j++){
                    sportistet[j] = sportistet[j+1];
                }
                sportistet[--index] = null;
                i--;
                count++;
                
            }
        }

        return count;
    }

    public static void main(String [] args){

        EkipiOlimpik eKS = new EkipiOlimpik("Kosova Team", 25);

        Sportisti spo = new Sportisti(202182476, "Sportistja 1", 20,'F');
        Sportisti s1 = new Futbollisti(202112345, "Vedat Muriqi", 27, 'M', 10);
        Sportisti s2 = new Futbollisti(202113456, "Arijanet Muric", 22, 'M', 12);
        Sportisti s3 = new Futbollisti(202148554, "Besjana Recica", 25, 'F', 13);
        Sportisti s4 = new Karateisti(202135858, "Valentina Limani", 24, 'F', "Kung-fu");
        Sportisti s5 = new Karateisti(202139958, "Besarta Hisenaj", 25, 'F', "Taekwondo");
        Sportisti s6 = new Karateisti(202138958, "Majlinda Kelmendi", 27, 'F', "Taekwondo");

        eKS.shtoSportistin(spo);
        eKS.shtoSportistin(s1);
        eKS.shtoSportistin(s2);
        eKS.shtoSportistin(s3);
        eKS.shtoSportistin(s4);
        eKS.shtoSportistin(s5);
        eKS.shtoSportistin(s6);

        System.out.println("Lista e te gjithe sportisteve te ekipit:");
        eKS.print();

        System.out.println("===========================================================================");

        Sportisti sProvo = new Futbollisti(202198726, "Granit Xhaka", 29, 'M', 20);
        System.out.println((sProvo.getGjinia()=='M'?"Sportisti ":"Sportistja ") + sProvo + (eKS.ekziston(sProvo)? " ":"nuk") + " gjendet ne ekip!");

        System.out.println("===========================================================================");

        System.out.println("Futbollistet femra:");
        eKS.shtypFutbollistetGjinia('F');

        System.out.println("===========================================================================");

        System.out.println("Karateistet me te ri se 26:");
        eKS.shtypKaratistetMeTeRi(26);

        System.out.println("===========================================================================");

        System.out.println("Sportistet me numer me te madh se 10:");
        Sportisti[] sV = eKS.ktheNumrat(10);
        for(int i=0; i<sV.length; i++) {
        	System.out.println(sV[i]);        	
        }

        System.out.println("===========================================================================");

        System.out.println("U fshine " + eKS.fshijSipasStilit("taekwondo") + " sportista (stili: Taekwondo).");
        System.out.println("U fshine " + eKS.fshijSipasStilit("kung-fu") + " sportista (stili: Kung-fu).");

        System.out.println("===========================================================================");

        System.out.println("Lista e sportisteve te ekipit pas largimit:");
        eKS.print();
    }
}

